
//embedded systems lab question 3 Aidan Cleary T00209564
//Lab 3: Digital sensors & equations in C

/*
q2:To test the result of the calculations. I downloaded the clinometer and tested
the mbed device. The tera term results were very close to the results on my phone app.
In my code I floated the X,Y,Z and roll angle on tera term. It would change results
every second.

High-pass filter, LMS algorithm and Kalman filter can be used to reduce offset and drift
there by improving the static stability and position accuracy by reducing noise, offset.

I initially used a /r/n after the printf statements. This resulted in a new line being
printed every second full of numbers. It got very confusing. I didn’t want to see a load
of numbers every second so decided to replace the code to /r instead. This just floated
the values I wanted to see every second on the tera term interface. This was far easier
to read and I am satisfied with the result of the program. One other issue is had was trying
to tell which way was the X, Y and Z axis, but after moving it about by hand I was able to
eventually figure it out.  In this lab it was also very interesting to see the way that
formulas are implemented into the C++ language.

*/

#include "mbed.h"//preprosser command
#include "MMA7660.h"//preprocesser command

#define PI 3.14159265//PI defined 

Serial pc(USBTX,USBRX);//serial transmission to pc via USBTX, USBRX
MMA7660 MMA(p28,p27);//IC2 pins associated with accelerometer

float calculateAngle(float x,float y,float z)
{
    float angle = 0;
// calculate the angle from the formula given in the instructions

    angle = (y*y) + (z*z);//bottom of the division line
    angle = sqrt (angle);//square root
    angle = x/angle;
    angle = atan (angle);//arctan of angle
    angle = angle *180/PI; //radians to degrees!
    return angle;
}

int main() //main program
{
    while (1) {
        pc.printf("    X%f     Y%f      Z%f     angle%.2f degrees\r", MMA.x(),
                  MMA.y(), MMA.z(), calculateAngle(MMA.x(), MMA.y(), MMA.z()));
        //i have used \r to repeat the function and keep the tera term tidy
        wait(1);//wait 1 second
    }
}